/**********************************************************************************************
	BEYCAN KAHRAMAN - 040020337 - 29.12.2006       -       System Programming - TURGUT UYAR
**********************************************************************************************/

#include <linux/config.h>
#include <linux/module.h>
#include <linux/moduleparam.h>
#include <linux/init.h>

#include <linux/kernel.h>	/* printk() */
#include <linux/slab.h>		/* kmalloc() */
#include <linux/fs.h>		/* everything... */
#include <linux/errno.h>	/* error codes */
#include <linux/types.h>	/* size_t */
#include <linux/proc_fs.h>
#include <linux/fcntl.h>	/* O_ACCMODE */
#include <linux/seq_file.h>
#include <linux/cdev.h>

#include <asm/system.h>		/* cli(), *_flags */
#include <asm/uaccess.h>	/* copy_*_user */
#include <asm/string.h>		/* string library */

#define MAXWORDLEN				64
#define DICTIONARY_MAJOR 		250
#define DICTIONARY_NR_DEVS 		2
#define ADD_WORD  				1
#define TRANSLATE 				2

int dictionary_major = DICTIONARY_MAJOR;
int dictionary_minor = 0;
int dictionary_nr_devs = DICTIONARY_NR_DEVS;
int dictionary_word_letterTr = -1;	// Read icin Kullanildi (Hangi Elemanin Hangi Harfinde Kaldik)
int dictionary_word_letterEn = -1;	// Read icin Kullanildi (Hangi Elemanin Hangi Harfinde Kaldik)

module_param(dictionary_major, int, S_IRUGO);
module_param(dictionary_minor, int, S_IRUGO);
module_param(dictionary_nr_devs, int, S_IRUGO);

MODULE_AUTHOR("Beycan Kahraman - 040020337");
MODULE_LICENSE("Dual BSD/GPL");

/**********************************************************************************************
	LINKED LIST   -   two dimensional
**********************************************************************************************/
typedef struct dicNodes
{
	char* stringEn;
	char* stringTr;
    struct dicNodes* nextEn;
    struct dicNodes* nextTr;
}dicNode;

void set(dicNode **node, char* En, char* Tr){
	(*node)->stringEn = (char*) kmalloc( sizeof(char)*(strlen(En) + 1), GFP_KERNEL );
	(*node)->stringTr = (char*) kmalloc( sizeof(char)*(strlen(Tr) + 1), GFP_KERNEL );
	strcpy((*node)->stringEn, En);
	strcpy((*node)->stringTr, Tr);
	(*node)->nextEn = NULL;
	(*node)->nextTr = NULL;
};

void nodeDelete(dicNode *node){
	kfree(node->stringEn);
	kfree(node->stringTr);
};

dicNode *newTmpTr = NULL;	// Read icin Kullanildi (Hangi Elemanda Kaldik)
dicNode *newTmpEn = NULL;	// Read icin Kullanildi (Hangi Elemanda Kaldik)

/**********************************************************************************************
	LIST FUNCTIONS
**********************************************************************************************/

void addToDictionary(dicNode **headEn, dicNode **headTr, dicNode *in){
	dicNode *tmp;
	if(*headEn == NULL){
		*headEn = in;
		*headTr = in;
	}else{
		if(strcmp((*headEn)->stringEn, in->stringEn) > 0){
			in->nextEn = *headEn;
			*headEn = in;
		}else{
			tmp = *headEn;
			while(tmp->nextEn && strcmp(tmp->nextEn->stringEn, in->stringEn) < 0)
				tmp = tmp->nextEn;
				
			if(tmp->nextEn){
				in->nextEn = tmp->nextEn;
				tmp->nextEn = in;
			}else{
				tmp->nextEn = in;
			}
		}
		if(strcmp((*headTr)->stringTr, in->stringTr) > 0){
			in->nextTr = *headTr;
			*headTr = in;
		}else{
			tmp = *headTr;
			while(tmp->nextTr && strcmp(tmp->nextTr->stringTr, in->stringTr) < 0)
				tmp = tmp->nextTr;
				
			if(tmp->nextTr){
				in->nextTr = tmp->nextTr;
				tmp->nextTr = in;
			}else{
				tmp->nextTr = in;
			}
		}
	}
}

void DeleteDictionary(dicNode **headEn){
	dicNode *tmp;
	tmp = *headEn;
	while((*headEn = tmp) != NULL){
		nodeDelete(*headEn);
		tmp = tmp->nextEn;
	}
	*headEn = NULL;
}

/**********************************************************************************************
	SPECIAL FUNCTIONS
**********************************************************************************************/

void seperateString(char* in, char* first, char* second){
	int i=0, j;

	while(in[i] != ':' && in[i] != '\0' && i < MAXWORDLEN-2){
		first[i] = in[i];
		++i;
	}
	first[i] = '\0';

	if(in[i] == '\0'){
		second[0] = '\0';
	}else{
		j = i+1;
		while(in[j] != '\0' && in[j] != ':' && j-i < MAXWORDLEN-1){
			second[j-i-1] = in[j];
			++j;
		}
		second[j-i-1] = '\0';
	}
}

int translate(dicNode* head, char* in, int devno){
	dicNode* tmp;
	tmp = head;

	while(tmp){
		if(devno){
			if(strcmp(tmp->stringTr, in) == 0){
				strcpy(in, tmp->stringEn);
				return 5;
			}
			else if(strcmp(tmp->stringTr, in) > 0)
			{
				strcpy(in, "");
				return -5;
			}
			tmp = tmp->nextTr;
		}else{
			if(strcmp(tmp->stringEn, in) == 0){
				strcpy(in, tmp->stringTr);
				return 6;
			}
			else if(strcmp(tmp->stringEn, in) > 0)
			{
				strcpy(in, "");
				return -6;
			}
			tmp = tmp->nextEn;
		}
	}
	strcpy(in, "");
	return -7;
}

void strTcat(char *b, char *a, int c, int d){
	int len = strlen(b), i;
	for(i=0; i<d-c; ++i)
		b[i+len] = a[i+c];
	b[i+len] = '\0';
}

/**********************************************************************************************
	READ n bit FUNCTIONS
**********************************************************************************************/

int readFromTrMemory(char* in, int count){
	if(!newTmpTr)
		return 0;
	int currentLen = strlen(newTmpTr->stringTr);
	int leftHere = currentLen - dictionary_word_letterTr + 1;
	if(count == leftHere){
		strTcat(in, newTmpTr->stringTr, dictionary_word_letterTr, currentLen);
		strcat(in, "\n");
		count = 0;
		dictionary_word_letterTr = currentLen;
		return leftHere;
	}else if(count > leftHere){
		strTcat(in, newTmpTr->stringTr, dictionary_word_letterTr, currentLen);
		strcat(in, "\n");
		count -= leftHere;
		dictionary_word_letterTr = 0;
		newTmpTr = newTmpTr->nextTr;
		return leftHere + readFromTrMemory(in, count);
	}else{
		strTcat(in, newTmpTr->stringTr, dictionary_word_letterTr, dictionary_word_letterTr + count);
		dictionary_word_letterTr += count;
		return count;
	}
}

int readFromEnMemory(char* in, int count){
	if(!newTmpEn)
		return 0;
	int currentLen = strlen(newTmpEn->stringEn);
	int leftHere = currentLen - dictionary_word_letterEn + 1;
	if(count == leftHere){
		strTcat(in, newTmpEn->stringEn, dictionary_word_letterEn, currentLen);
		strcat(in, "\n");
		count = 0;
		dictionary_word_letterEn = currentLen;
		return leftHere;
	}else if(count > leftHere){
		strTcat(in, newTmpEn->stringEn, dictionary_word_letterEn, currentLen);
		strcat(in, "\n");
		count -= leftHere;
		dictionary_word_letterEn = 0;
		newTmpEn = newTmpEn->nextEn;
		return leftHere + readFromEnMemory(in, count);
	}else{
		strTcat(in, newTmpEn->stringEn, dictionary_word_letterEn, dictionary_word_letterEn + count);
		dictionary_word_letterEn += count;
		return count;
	}
}

/**********************************************************************************************
	DICTIONARY DEVICE
**********************************************************************************************/

struct dictionary_dev {
	dicNode *headEn;
	dicNode *headTr;
	dicNode *newNode;
	struct cdev cdev;
};

struct dictionary_dev *dictionary_devices;

/**********************************************************************************************
	DEVICE RELATED FUNCTIONS
**********************************************************************************************/

int dictionary_trim(struct dictionary_dev *dev)
{
	return 0;
}

int dictionary_open(struct inode *inode, struct file *filp)
{
	struct dictionary_dev *dev;

	dev = container_of(inode->i_cdev, struct dictionary_dev, cdev);
	filp->private_data = dev;

	return 0;
}

int dictionary_release(struct inode *inode, struct file *filp)
{
	dictionary_word_letterTr = -1;
	dictionary_word_letterEn = -1;
	return 0;
}

/**********************************************************************************************
	READ FUNCTION   <------------------------------------------------
**********************************************************************************************/

ssize_t dictionary_read(struct file *filp, char __user *buf, size_t count, loff_t *f_pos)
{
	int devno = iminor(filp->f_dentry->d_inode);

	char *in = (char *)buf;

	if(dictionary_word_letterTr < 0){	// first attempt to read Turkish
		dictionary_word_letterTr = 0;
		newTmpTr = dictionary_devices->headTr;
	}
	if(dictionary_word_letterEn < 0){	// first attempt to read English
		dictionary_word_letterEn = 0;
		newTmpEn = dictionary_devices->headEn;
	}

	strcpy(in, "");

	if(devno > 0){		// lets Read Turkish
		if(!newTmpTr)
			return 0;
		return readFromTrMemory(in, count);
	}
	if(!newTmpEn)		// read English
		return 0;
	return readFromEnMemory(in, count);
}

ssize_t dictionary_write(struct file *filp, const char __user *buf, size_t count,loff_t *f_pos)
{
	return 0;
}

loff_t dictionary_llseek(struct file *filp, loff_t off, int whence)
{
	return 0;
}

/**********************************************************************************************
	IOCTL FUNCTION   <------------------------------------------------
**********************************************************************************************/

int dictionary_ioctl(struct inode *inode, struct file *filp,unsigned int cmd, unsigned long arg)
{
	char *in = (char *)arg;
	int devno = iminor(filp->f_dentry->d_inode);
	char first[MAXWORDLEN], second[MAXWORDLEN];

	switch(cmd) {
	  case ADD_WORD:	// We're adding given words to dictionary
		seperateString(in, first, second); 
		dictionary_devices->newNode = (dicNode*) kmalloc( sizeof(dicNode), GFP_KERNEL );

		if(devno)
			set(&(dictionary_devices->newNode), second, first);
		else
			set(&(dictionary_devices->newNode), first, second);

		addToDictionary(&(dictionary_devices->headEn), &(dictionary_devices->headTr), dictionary_devices->newNode);
		
		return 12;

		break;
        
	  case TRANSLATE: 	// Making Translation
		if(devno > 0){
			translate(dictionary_devices->headTr, in, devno);
			return 11;
		}else{
			translate(dictionary_devices->headEn, in, devno);
			return 10;
		}
		break;

	  default:
		return -8;
	}
	return 8;
}

struct file_operations dictionary_fops = {
	.owner =    THIS_MODULE,
	.llseek =   dictionary_llseek,
	.read =     dictionary_read,
	.write =    dictionary_write,
	.ioctl =    dictionary_ioctl,
	.open =     dictionary_open,
	.release =  dictionary_release,
};

void dictionary_cleanup_module(void)
{
	int i;
	dev_t devno = MKDEV(dictionary_major, dictionary_minor);

	if (dictionary_devices) {
		for (i = 0; i < dictionary_nr_devs; i++) {
			dictionary_trim(dictionary_devices + i);
			cdev_del(&dictionary_devices[i].cdev);
		}
		kfree(dictionary_devices);
	}

	unregister_chrdev_region(devno, dictionary_nr_devs);
}

static void dictionary_setup_cdev(struct dictionary_dev *dev, int index)
{
	int err, devno = MKDEV(dictionary_major, dictionary_minor + index);
    
	cdev_init(&dev->cdev, &dictionary_fops);
	dev->cdev.owner = THIS_MODULE;
	dev->cdev.ops = &dictionary_fops;
	err = cdev_add (&dev->cdev, devno, 1);
	if (err)
		printk(KERN_NOTICE "Error %d adding dictionary%d", err, index);
}

int dictionary_init_module(void)
{
	int result, i;
	dev_t dev = 0;

	if (dictionary_major) {
		dev = MKDEV(dictionary_major, dictionary_minor);
		result = register_chrdev_region(dev, dictionary_nr_devs, "dictionary");
	} else {
		result = alloc_chrdev_region(&dev, dictionary_minor, dictionary_nr_devs, "dictionary");
		dictionary_major = MAJOR(dev);
	}
	if (result < 0) {
		printk(KERN_WARNING "dictionary: can't get major %d\n", dictionary_major);
		return result;
	}

	dictionary_devices = kmalloc(dictionary_nr_devs * sizeof(struct dictionary_dev), GFP_KERNEL);
	if (!dictionary_devices) {
		result = -ENOMEM;
		goto fail;
	}
	memset(dictionary_devices, 0, dictionary_nr_devs * sizeof(struct dictionary_dev));

        /* Initialize each device. */
	for (i = 0; i < dictionary_nr_devs; i++) {
		dictionary_devices[i].headEn = NULL;
		dictionary_devices[i].headTr = NULL;
		dictionary_setup_cdev(&dictionary_devices[i], i);
	}

	return 0; /* succeed */

  fail:
	dictionary_cleanup_module();
	return result;
}

module_init(dictionary_init_module);
module_exit(dictionary_cleanup_module);
